Index: python/aubio/task/params.py
===================================================================
--- python/aubio/task/params.py	(revision 650e39b95abdb31b0efd5bcffd3d6e09f01ea658)
+++ python/aubio/task/params.py	(revision 4798fdf068bb6b3c8d6eb5529c5628a6505fa564)
@@ -26,6 +26,7 @@
 		self.yinfftthresh = 0.85 
 		self.pitchsmooth = 0
-		self.pitchmin=10.
+		self.pitchmin=20.
 		self.pitchmax=20000.
+		self.pitchdelay = -0.5
 		self.dcthreshold = -1.
 		self.omode = aubio_pitchm_freq
Index: python/aubio/task/pitch.py
===================================================================
--- python/aubio/task/pitch.py	(revision 650e39b95abdb31b0efd5bcffd3d6e09f01ea658)
+++ python/aubio/task/pitch.py	(revision 4798fdf068bb6b3c8d6eb5529c5628a6505fa564)
@@ -79,5 +79,5 @@
 					else:
 						pitch.append(-1.)
-				return time,pitch #0,aubio_miditofreq(float(floatpit))
+				return time,pitch
 			except ValueError:
 				# FIXME very weak check
@@ -121,5 +121,5 @@
 			if pitch[i] == "nan" or pitch[i] == -1:
 				pitch[i] = -1
-		time = [ i*self.params.step for i in range(len(pitch)) ]
+		time = [ (i+self.params.pitchdelay)*self.params.step for i in range(len(pitch)) ]
 		#print len(timet),len(pitcht)
 		#print len(time),len(pitch)
@@ -153,14 +153,13 @@
 
 	def plot(self,pitch,wplot,oplots,outplot=None):
-		import numarray
 		import Gnuplot
 
-		downtime = self.params.step*numarray.arange(len(pitch))
+		time = [ (i+self.params.pitchdelay)*self.params.step for i in range(len(pitch)) ]
 		pitch = [aubio_freqtomidi(i) for i in pitch]
-		oplots.append(Gnuplot.Data(downtime,pitch,with='lines',
+		oplots.append(Gnuplot.Data(time,pitch,with='lines',
 			title=self.params.pitchmode))
 
 			
-	def plotplot(self,wplot,oplots,outplot=None,multiplot = 0, midi = 1):
+	def plotplot(self,wplot,oplots,outplot=None,multiplot = 1, midi = 1):
 		from aubio.gnuplot import gnuplot_init, audio_to_array, make_audio_plot
 		import re
@@ -185,4 +184,5 @@
 		# plot waveform and onsets
 		g('set size 1,0.3')
+		g('set ytics 10')
 		g('set origin 0,0.7')
 		g('set xrange [0:%f]' % max(time)) 
@@ -203,5 +203,5 @@
 			g('set yrange [100:%f]' % self.params.pitchmax) 
 		else: 
-			g.ylabel('pitch (midi)')
+			g.ylabel('midi')
 			g('set yrange [%f:%f]' % (aubio_freqtomidi(self.params.pitchmin), aubio_freqtomidi(self.params.pitchmax)))
 		g('set key right top')
Index: python/aubiopitch
===================================================================
--- python/aubiopitch	(revision 650e39b95abdb31b0efd5bcffd3d6e09f01ea658)
+++ python/aubiopitch	(revision 4798fdf068bb6b3c8d6eb5529c5628a6505fa564)
@@ -40,13 +40,14 @@
         parser.add_option("-D","--delay",
                           action="store", dest="delay",  
-                          help="number of seconds to take back [default=system]\
-                          default system delay is 2*hopsize/samplerate")
-        parser.add_option("-L","--localmin",
-                          action="store_true", dest="localmin", default=False, 
-                          help="use local minima after peak detection")
-        parser.add_option("-c","--cut",
-                          action="store_true", dest="cut", default=False,
-                          help="cut input sound file at detected labels \
-                          best used with option -L")
+                          help="number of seconds frames to take back [default=0]")
+	parser.add_option("-S","--smoothing",
+			  action="store", dest="smoothing", default=False, 
+			  help="use a median filter of N frames [default=0]")
+	parser.add_option("-M","--maximum",
+			  action="store", dest="pitchmax", default=False, 
+			  help="maximum pitch value to look for (Hz) [default=20000]")
+	parser.add_option("-l","--minimum",
+			  action="store", dest="pitchmin", default=False, 
+			  help="minimum pitch value to look for (Hz) [default=20]")
         # to be implemented
         parser.add_option("-n","--note",
@@ -56,11 +57,11 @@
         parser.add_option("-p","--plot",
                           action="store_true", dest="plot", default=False, 
-                          help="NOT IMPLEMENTED draw plot")
+                          help="draw plot of the pitch track")
         parser.add_option("-O","--outplot",
                           action="store", dest="outplot", default=None, 
-                          help="NOT IMPLEMENTED save plot to output.{ps,png}")
+                          help="save the plot to output.{ps,png,svg} instead of displaying it")
         parser.add_option("-v","--verbose",
                           action="store_true", dest="verbose", default=False,
-                          help="make lots of noise [default]")
+                          help="make lots of noise")
         parser.add_option("-q","--quiet",
                           action="store_false", dest="verbose", default=False, 
@@ -93,8 +94,10 @@
 params.silence    = float(options.silence)
 params.verbose    = options.verbose
+if options.smoothing: params.pitchsmooth = int(options.smoothing)
+if options.pitchmax:  params.pitchmax    = int(options.pitchmax)
+if options.pitchmin:  params.pitchmin    = int(options.pitchmin)
 #mintol     = float(options.mintol)*step
 # default take back system delay
-if options.delay: delay = float(options.delay)
-else:             delay = 2./params.step
+if options.delay: params.pitchdelay = float(options.delay)
 
 if options.note: